Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 9019)
@@ -28,7 +28,5 @@
    USE ldfslp             ! Lateral diffusion: slopes of neutral surfaces
    USE tradmp             ! Tracer damping
-#if defined key_zdftke
    USE zdftke             ! TKE vertical physics
-#endif
    USE eosbn2             ! Equation of state (eos_bn2 routine)
    USE zdfmxl             ! Mixed layer depth
@@ -38,7 +36,4 @@
    USE asmpar             ! Parameters for the assmilation interface
    USE zdfmxl             ! mixed layer depth
-#if defined key_lim2
-   USE ice_2
-#endif
 #if defined key_lim3
    USE ice
@@ -94,10 +89,8 @@
             IF( nitbkg_r == nit000 - 1 ) THEN      ! Treat special case when nitbkg = 0
                zdate = REAL( ndastp )
-#if defined key_zdftke
-               ! lk_zdftke=T :   Read turbulent kinetic energy ( en )
-               IF(lwp) WRITE(numout,*) ' Reading TKE (en) from restart...'
-               CALL tke_rst( nit000, 'READ' )               ! lk_zdftke=T :   Read turbulent kinetic energy ( en )
-
-#endif
+               IF( ln_zdftke ) THEN                   ! read turbulent kinetic energy ( en )
+                  IF(lwp) WRITE(numout,*) ' Reading TKE (en) from restart...'
+                  CALL tke_rst( nit000, 'READ' )
+               ENDIF
             ELSE
                zdate = REAL( ndastp )
@@ -111,7 +104,5 @@
             CALL iom_rstput( kt, nitbkg_r, inum, 'sn'     , tsn(:,:,:,jp_sal) )
             CALL iom_rstput( kt, nitbkg_r, inum, 'sshn'   , sshn              )
-#if defined key_zdftke
-            CALL iom_rstput( kt, nitbkg_r, inum, 'en'     , en                )
-#endif
+            IF( ln_zdftke )   CALL iom_rstput( kt, nitbkg_r, inum, 'en'     , en                )
             !
             CALL iom_close( inum )
@@ -148,10 +139,11 @@
             CALL iom_rstput( kt, nitdin_r, inum, 'sn'     , tsn(:,:,:,jp_sal) )
             CALL iom_rstput( kt, nitdin_r, inum, 'sshn'   , sshn              )
-#if defined key_lim2 || defined key_lim3
-            IF( nn_ice == 2  .OR.  nn_ice == 3 ) THEN
-	            IF( ALLOCATED(frld) ) THEN
-                  CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', 1._wp - frld(:,:)   )
+#if defined key_lim3
+            IF( nn_ice == 2 ) THEN
+	            IF( ALLOCATED(at_i) ) THEN
+                  CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', at_i(:,:)   )
                ELSE
-		            CALL ctl_warn('Ice concentration not written to background as ice variable frld not allocated on this timestep')
+		            CALL ctl_warn('asm_bkg_wri: Ice concentration not written to background ',   &
+		               &          'as ice variable at_i not allocated on this timestep')
 	            ENDIF
             ENDIF
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 9019)
@@ -22,22 +22,22 @@
    !!   seaice_asm_inc : Apply the seaice increment
    !!----------------------------------------------------------------------
-   USE wrk_nemo         ! Memory Allocation
-   USE par_oce          ! Ocean space and time domain variables
-   USE dom_oce          ! Ocean space and time domain
-   USE domvvl           ! domain: variable volume level
-   USE oce              ! Dynamics and active tracers defined in memory
-   USE ldfdyn           ! lateral diffusion: eddy viscosity coefficients
-   USE eosbn2           ! Equation of state - in situ and potential density
-   USE zpshde           ! Partial step : Horizontal Derivative
-   USE iom              ! Library to read input files
-   USE asmpar           ! Parameters for the assmilation interface
-   USE c1d              ! 1D initialization
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-#if defined key_lim2
-   USE ice_2            ! LIM2
-#endif
-   USE sbc_oce          ! Surface boundary condition variables.
-   USE diaobs, ONLY: calc_date     ! Compute the calendar date on a given step
+   USE oce             ! Dynamics and active tracers defined in memory
+   USE par_oce         ! Ocean space and time domain variables
+   USE dom_oce         ! Ocean space and time domain
+   USE domvvl          ! domain: variable volume level
+   USE ldfdyn          ! lateral diffusion: eddy viscosity coefficients
+   USE eosbn2          ! Equation of state - in situ and potential density
+   USE zpshde          ! Partial step : Horizontal Derivative
+   USE asmpar          ! Parameters for the assmilation interface
+   USE c1d             ! 1D initialization
+   USE sbc_oce         ! Surface boundary condition variables.
+   USE diaobs   , ONLY : calc_date     ! Compute the calendar date on a given step
+#if defined key_lim3
+   USE ice      , ONLY : hm_i, at_i, at_i_b
+#endif
+   !
+   USE in_out_manager  ! I/O manager
+   USE iom             ! Library to read input files
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
@@ -127,5 +127,5 @@
       REAL(wp) :: zdate_inc    ! Time axis in increments file
       !
-      REAL(wp), POINTER, DIMENSION(:,:) ::   hdiv   ! 2D workspace
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   zhdiv   ! 2D workspace
       !!
       NAMELIST/nam_asminc/ ln_bkgwri,                                      &
@@ -173,26 +173,17 @@
       ENDIF
 
-      nitbkg_r    = nitbkg    + nit000 - 1  ! Background time referenced to nit000
-      nitdin_r    = nitdin    + nit000 - 1  ! Background time for DI referenced to nit000
-      nitiaustr_r = nitiaustr + nit000 - 1  ! Start of IAU interval referenced to nit000
-      nitiaufin_r = nitiaufin + nit000 - 1  ! End of IAU interval referenced to nit000
-
-      iiauper = nitiaufin_r - nitiaustr_r + 1  ! IAU interval length
-      icycper = nitend      - nit000      + 1  ! Cycle interval length
-
-      ! Date of final time step
-      CALL calc_date( nitend, ditend_date )
-
-      ! Background time for Jb referenced to ndate0
-      CALL calc_date( nitbkg_r, ditbkg_date )
-
-      ! Background time for DI referenced to ndate0
-      CALL calc_date( nitdin_r, ditdin_date )
-
-      ! IAU start time referenced to ndate0
-      CALL calc_date( nitiaustr_r, ditiaustr_date )
-
-      ! IAU end time referenced to ndate0
-      CALL calc_date( nitiaufin_r, ditiaufin_date )
+      nitbkg_r    = nitbkg    + nit000 - 1            ! Background time referenced to nit000
+      nitdin_r    = nitdin    + nit000 - 1            ! Background time for DI referenced to nit000
+      nitiaustr_r = nitiaustr + nit000 - 1            ! Start of IAU interval referenced to nit000
+      nitiaufin_r = nitiaufin + nit000 - 1            ! End of IAU interval referenced to nit000
+
+      iiauper     = nitiaufin_r - nitiaustr_r + 1     ! IAU interval length
+      icycper     = nitend      - nit000      + 1     ! Cycle interval length
+
+      CALL calc_date( nitend     , ditend_date    )   ! Date of final time step
+      CALL calc_date( nitbkg_r   , ditbkg_date    )   ! Background time for Jb referenced to ndate0
+      CALL calc_date( nitdin_r   , ditdin_date    )   ! Background time for DI referenced to ndate0
+      CALL calc_date( nitiaustr_r, ditiaustr_date )   ! IAU start time referenced to ndate0
+      CALL calc_date( nitiaufin_r, ditiaufin_date )   ! IAU end time referenced to ndate0
 
       IF(lwp) THEN
@@ -266,5 +257,5 @@
          ALLOCATE( wgtiau( icycper ) )
 
-         wgtiau(:) = 0.0
+         wgtiau(:) = 0._wp
 
          IF ( niaufn == 0 ) THEN
@@ -339,21 +330,17 @@
       ALLOCATE( ssh_bkginc(jpi,jpj)   )
       ALLOCATE( seaice_bkginc(jpi,jpj))
+      t_bkginc     (:,:,:) = 0._wp
+      s_bkginc     (:,:,:) = 0._wp
+      u_bkginc     (:,:,:) = 0._wp
+      v_bkginc     (:,:,:) = 0._wp
+      ssh_bkginc   (:,:)   = 0._wp
+      seaice_bkginc(:,:)   = 0._wp
 #if defined key_asminc
       ALLOCATE( ssh_iau(jpi,jpj)      )
+      ssh_iau      (:,:)   = 0._wp
 #endif
 #if defined key_cice && defined key_asminc
-      ALLOCATE( ndaice_da(jpi,jpj)      )
-#endif
-      t_bkginc(:,:,:) = 0.0
-      s_bkginc(:,:,:) = 0.0
-      u_bkginc(:,:,:) = 0.0
-      v_bkginc(:,:,:) = 0.0
-      ssh_bkginc(:,:) = 0.0
-      seaice_bkginc(:,:) = 0.0
-#if defined key_asminc
-      ssh_iau(:,:)    = 0.0
-#endif
-#if defined key_cice && defined key_asminc
-      ndaice_da(:,:) = 0.0
+      ALLOCATE( ndaice_da(jpi,jpj)    )
+      ndaice_da    (:,:)   = 0._wp
 #endif
       IF ( ( ln_trainc ).OR.( ln_dyninc ).OR.( ln_sshinc ).OR.( ln_seaiceinc ) ) THEN
@@ -441,26 +428,26 @@
       IF ( ln_dyninc .AND. nn_divdmp > 0 ) THEN
          !
-         CALL wrk_alloc( jpi,jpj,   hdiv ) 
+         ALLOCATE( zhdiv(jpi,jpj) ) 
          !
          DO jt = 1, nn_divdmp
             !
-            DO jk = 1, jpkm1           ! hdiv = e1e1 * div
-               hdiv(:,:) = 0._wp
+            DO jk = 1, jpkm1           ! zhdiv = e1e1 * div
+               zhdiv(:,:) = 0._wp
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     hdiv(ji,jj) = (  e2u(ji  ,jj) * e3u_n(ji  ,jj,jk) * u_bkginc(ji  ,jj,jk)    &
-                        &           - e2u(ji-1,jj) * e3u_n(ji-1,jj,jk) * u_bkginc(ji-1,jj,jk)    &
-                        &           + e1v(ji,jj  ) * e3v_n(ji,jj  ,jk) * v_bkginc(ji,jj  ,jk)    &
-                        &           - e1v(ji,jj-1) * e3v_n(ji,jj-1,jk) * v_bkginc(ji,jj-1,jk)  ) / e3t_n(ji,jj,jk)
+                     zhdiv(ji,jj) = (  e2u(ji  ,jj) * e3u_n(ji  ,jj,jk) * u_bkginc(ji  ,jj,jk)    &
+                        &            - e2u(ji-1,jj) * e3u_n(ji-1,jj,jk) * u_bkginc(ji-1,jj,jk)    &
+                        &            + e1v(ji,jj  ) * e3v_n(ji,jj  ,jk) * v_bkginc(ji,jj  ,jk)    &
+                        &            - e1v(ji,jj-1) * e3v_n(ji,jj-1,jk) * v_bkginc(ji,jj-1,jk)  ) / e3t_n(ji,jj,jk)
                   END DO
                END DO
-               CALL lbc_lnk( hdiv, 'T', 1. )   ! lateral boundary cond. (no sign change)
+               CALL lbc_lnk( zhdiv, 'T', 1. )   ! lateral boundary cond. (no sign change)
                !
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
                      u_bkginc(ji,jj,jk) = u_bkginc(ji,jj,jk)                         &
-                        &               + 0.2_wp * ( hdiv(ji+1,jj) - hdiv(ji  ,jj) ) * r1_e1u(ji,jj) * umask(ji,jj,jk)
+                        &               + 0.2_wp * ( zhdiv(ji+1,jj) - zhdiv(ji  ,jj) ) * r1_e1u(ji,jj) * umask(ji,jj,jk)
                      v_bkginc(ji,jj,jk) = v_bkginc(ji,jj,jk)                         &
-                        &               + 0.2_wp * ( hdiv(ji,jj+1) - hdiv(ji,jj  ) ) * r1_e2v(ji,jj) * vmask(ji,jj,jk) 
+                        &               + 0.2_wp * ( zhdiv(ji,jj+1) - zhdiv(ji,jj  ) ) * r1_e2v(ji,jj) * vmask(ji,jj,jk) 
                   END DO
                END DO
@@ -469,5 +456,5 @@
          END DO
          !
-         CALL wrk_dealloc( jpi,jpj,   hdiv ) 
+         DEALLOCATE( zhdiv ) 
          !
       ENDIF
@@ -815,5 +802,5 @@
       INTEGER  ::   it
       REAL(wp) ::   zincwgt   ! IAU weight for current time step
-#if defined key_lim2
+#if defined key_lim3
       REAL(wp), DIMENSION(jpi,jpj) ::   zofrld, zohicif, zseaicendg, zhicifinc  ! LIM
       REAL(wp) ::   zhicifmin = 0.5_wp      ! ice minimum depth in metres
@@ -837,20 +824,19 @@
             ENDIF
             !
-            ! Sea-ice : LIM-3 case (to add)
-            !
-#if defined key_lim2
-            ! Sea-ice : LIM-2 case
-            zofrld (:,:) = frld(:,:)
-            zohicif(:,:) = hicif(:,:)
-            !
-            frld  = MIN( MAX( frld (:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-            pfrld = MIN( MAX( pfrld(:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
-            fr_i(:,:) = 1.0_wp - frld(:,:)        ! adjust ice fraction
-            !
-            zseaicendg(:,:) = zofrld(:,:) - frld(:,:)   ! find out actual sea ice nudge applied
+            ! Sea-ice : LIM-3 case
+            !
+#if defined key_lim3
+            zofrld (:,:) = 1._wp - at_i(:,:)
+            zohicif(:,:) = hm_i(:,:)
+            !
+            at_i  (:,:) = 1. - MIN( MAX( 1.-at_i  (:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
+            at_i_b(:,:) = 1. - MIN( MAX( 1.-at_i_b(:,:) - seaice_bkginc(:,:) * zincwgt, 0.0_wp), 1.0_wp)
+            fr_i(:,:) = at_i(:,:)        ! adjust ice fraction
+            !
+            zseaicendg(:,:) = zofrld(:,:) - (1. - at_i(:,:))   ! find out actual sea ice nudge applied
             !
             ! Nudge sea ice depth to bring it up to a required minimum depth
-            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-               zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
+            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hm_i(:,:) < zhicifmin ) 
+               zhicifinc(:,:) = (zhicifmin - hm_i(:,:)) * zincwgt    
             ELSEWHERE
                zhicifinc(:,:) = 0.0_wp
@@ -858,6 +844,5 @@
             !
             ! nudge ice depth
-            hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-            phicif(:,:) = phicif(:,:) + zhicifinc(:,:)       
+            hm_i (:,:) = hm_i (:,:) + zhicifinc(:,:)
             !
             ! seaice salinity balancing (to add)
@@ -888,27 +873,26 @@
             neuler = 0                    ! Force Euler forward step
             !
-            ! Sea-ice : LIM-3 case (to add)
-            !
-#if defined key_lim2
-            ! Sea-ice : LIM-2 case.
-            zofrld(:,:)=frld(:,:)
-            zohicif(:,:)=hicif(:,:)
+            ! Sea-ice : LIM-3 case
+            !
+#if defined key_lim3
+            zofrld (:,:) = 1._wp - at_i(:,:)
+            zohicif(:,:) = hm_i(:,:)
             ! 
             ! Initialize the now fields the background + increment
-            frld (:,:) = MIN( MAX( frld(:,:) - seaice_bkginc(:,:), 0.0_wp), 1.0_wp)
-            pfrld(:,:) = frld(:,:) 
-            fr_i (:,:) = 1.0_wp - frld(:,:)                ! adjust ice fraction
-            zseaicendg(:,:) = zofrld(:,:) - frld(:,:)      ! find out actual sea ice nudge applied
+            at_i(:,:) = 1. - MIN( MAX( 1.-at_i(:,:) - seaice_bkginc(:,:), 0.0_wp), 1.0_wp)
+            at_i_b(:,:) = at_i(:,:) 
+            fr_i(:,:) = at_i(:,:)        ! adjust ice fraction
+            !
+            zseaicendg(:,:) = zofrld(:,:) - (1. - at_i(:,:))   ! find out actual sea ice nudge applied
             !
             ! Nudge sea ice depth to bring it up to a required minimum depth
-            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hicif(:,:) < zhicifmin ) 
-               zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
+            WHERE( zseaicendg(:,:) > 0.0_wp .AND. hm_i(:,:) < zhicifmin ) 
+               zhicifinc(:,:) = (zhicifmin - hm_i(:,:)) * zincwgt    
             ELSEWHERE
-               zhicifinc(:,:) = 0._wp
+               zhicifinc(:,:) = 0.0_wp
             END WHERE
             !
             ! nudge ice depth
-            hicif (:,:) = hicif (:,:) + zhicifinc(:,:)
-            phicif(:,:) = phicif(:,:)       
+            hm_i (:,:) = hm_i (:,:) + zhicifinc(:,:)
             !
             ! seaice salinity balancing (to add)
@@ -932,5 +916,5 @@
          ENDIF
 
-!#if defined defined key_lim2 || defined key_cice
+!#if defined defined key_lim3 || defined key_cice
 !
 !            IF (ln_seaicebal ) THEN       
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 9019)
@@ -55,18 +55,11 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::  tem
       REAL(wp), POINTER, DIMENSION(:,:) ::  sal
-#if defined key_lim2
-      LOGICAL                           ::   ll_frld
-      LOGICAL                           ::   ll_hicif
-      LOGICAL                           ::   ll_hsnif
-      REAL(wp), POINTER, DIMENSION(:)   ::   frld
-      REAL(wp), POINTER, DIMENSION(:)   ::   hicif
-      REAL(wp), POINTER, DIMENSION(:)   ::   hsnif
-#elif defined key_lim3
+#if defined key_lim3
       LOGICAL                           ::   ll_a_i
-      LOGICAL                           ::   ll_ht_i
-      LOGICAL                           ::   ll_ht_s
+      LOGICAL                           ::   ll_h_i
+      LOGICAL                           ::   ll_h_s
       REAL(wp), POINTER, DIMENSION(:,:) ::   a_i    !: now ice leads fraction climatology
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ht_i   !: Now ice  thickness climatology
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ht_s   !: now snow thickness
+      REAL(wp), POINTER, DIMENSION(:,:) ::   h_i    !: Now ice  thickness climatology
+      REAL(wp), POINTER, DIMENSION(:,:) ::   h_s    !: now snow thickness
 #endif
 #if defined key_top
